diff -pruN 0.0~git20200107.26c1120-1fakesync1/AUTHORS 0.0~git20201119.04c754f-2/AUTHORS
--- 0.0~git20200107.26c1120-1fakesync1/AUTHORS	2020-01-07 19:41:36.000000000 +0000
+++ 0.0~git20201119.04c754f-2/AUTHORS	2020-11-19 17:31:50.000000000 +0000
@@ -1,16 +1,36 @@
 Aaron Lehmann <aaron.lehmann@docker.com>
 Akash Gupta <akagup@microsoft.com>
+Akihiro Suda <akihiro.suda.cz@hco.ntt.co.jp>
 Akihiro Suda <suda.akihiro@lab.ntt.co.jp>
+Akihiro Suda <suda.kyoto@gmail.com>
 Andrew Pennebaker <apennebaker@datapipe.com>
 Brandon Philips <brandon.philips@coreos.com>
+Brian Goff <cpuguy83@gmail.com>
 Christopher Jones <tophj@linux.vnet.ibm.com>
 Daniel, Dao Quang Minh <dqminh89@gmail.com>
+Darren Stahl <darst@microsoft.com>
+Derek McGowan <derek@mcg.dev>
 Derek McGowan <derek@mcgstyle.net>
 Edward Pilatowicz <edward.pilatowicz@oracle.com>
 Ian Campbell <ijc@docker.com>
+Ivan Markin <sw@nogoegst.net>
 Justin Cormack <justin.cormack@docker.com>
 Justin Cummins <sul3n3t@gmail.com>
+Kasper Fabæch Brandt <poizan@poizan.dk>
+Kir Kolyshkin <kolyshkin@gmail.com>
+Michael Crosby <crosbymichael@gmail.com>
+Michael Wan <zirenwan@gmail.com>
+Niels de Vos <ndevos@redhat.com>
 Phil Estes <estesp@gmail.com>
+Phil Estes <estesp@linux.vnet.ibm.com>
+Sam Whited <sam@samwhited.com>
+Shengjing Zhu <zhsj@debian.org>
 Stephen J Day <stephen.day@docker.com>
+Tibor Vass <tibor@docker.com>
 Tobias Klauser <tklauser@distanz.ch>
+Tom Faulhaber <tffaulha@amazon.com>
 Tonis Tiigi <tonistiigi@gmail.com>
+Trevor Porter <trkporter@ucdavis.edu>
+Wei Fu <fuweid89@gmail.com>
+Wilbert van de Ridder <wilbert.ridder@gmail.com>
+Xiaodong Ye <xiaodongy@vmware.com>
diff -pruN 0.0~git20200107.26c1120-1fakesync1/commands/ls.go 0.0~git20201119.04c754f-2/commands/ls.go
--- 0.0~git20200107.26c1120-1fakesync1/commands/ls.go	2020-01-07 19:41:36.000000000 +0000
+++ 0.0~git20201119.04c754f-2/commands/ls.go	2020-11-19 17:31:50.000000000 +0000
@@ -44,8 +44,10 @@ var LSCmd = &cobra.Command{
 		for _, entry := range bm.Resource {
 			for _, path := range entry.Path {
 				if os.FileMode(entry.Mode)&os.ModeSymlink != 0 {
+					//nolint:unconvert
 					fmt.Fprintf(w, "%v\t%v\t%v\t%v\t%v -> %v\n", os.FileMode(entry.Mode), entry.User, entry.Group, humanize.Bytes(uint64(entry.Size)), path, entry.Target)
 				} else {
+					//nolint:unconvert
 					fmt.Fprintf(w, "%v\t%v\t%v\t%v\t%v\n", os.FileMode(entry.Mode), entry.User, entry.Group, humanize.Bytes(uint64(entry.Size)), path)
 				}
 
diff -pruN 0.0~git20200107.26c1120-1fakesync1/context.go 0.0~git20201119.04c754f-2/context.go
--- 0.0~git20200107.26c1120-1fakesync1/context.go	2020-01-07 19:41:36.000000000 +0000
+++ 0.0~git20201119.04c754f-2/context.go	2020-11-19 17:31:50.000000000 +0000
@@ -596,7 +596,7 @@ func (c *context) Walk(fn filepath.WalkF
 			return err
 		}
 	}
-	return c.pathDriver.Walk(root, func(p string, fi os.FileInfo, err error) error {
+	return c.pathDriver.Walk(root, func(p string, fi os.FileInfo, _ error) error {
 		contained, err := c.containWithRoot(p, root)
 		return fn(contained, fi, err)
 	})
@@ -613,12 +613,6 @@ func (c *context) fullpath(p string) (st
 	return p, nil
 }
 
-// contain cleans and santizes the filesystem path p to be an absolute path,
-// effectively relative to the context root.
-func (c *context) contain(p string) (string, error) {
-	return c.containWithRoot(p, c.root)
-}
-
 // containWithRoot cleans and santizes the filesystem path p to be an absolute path,
 // effectively relative to the passed root. Extra care should be used when calling this
 // instead of contain. This is needed for Walk, as if context root is a symlink,
diff -pruN 0.0~git20200107.26c1120-1fakesync1/continuityfs/fuse.go 0.0~git20201119.04c754f-2/continuityfs/fuse.go
--- 0.0~git20200107.26c1120-1fakesync1/continuityfs/fuse.go	2020-01-07 19:41:36.000000000 +0000
+++ 0.0~git20201119.04c754f-2/continuityfs/fuse.go	2020-11-19 17:31:50.000000000 +0000
@@ -131,7 +131,7 @@ type fileHandler struct {
 func (h *fileHandler) Read(ctx context.Context, req *fuse.ReadRequest, resp *fuse.ReadResponse) error {
 	if h.offset != req.Offset {
 		if seeker, ok := h.reader.(io.Seeker); ok {
-			if _, err := seeker.Seek(req.Offset, os.SEEK_SET); err != nil {
+			if _, err := seeker.Seek(req.Offset, io.SeekStart); err != nil {
 				logrus.Debugf("Error seeking: %v", err)
 				return err
 			}
diff -pruN 0.0~git20200107.26c1120-1fakesync1/debian/changelog 0.0~git20201119.04c754f-2/debian/changelog
--- 0.0~git20200107.26c1120-1fakesync1/debian/changelog	2020-07-22 00:09:21.000000000 +0000
+++ 0.0~git20201119.04c754f-2/debian/changelog	2020-11-26 03:10:49.000000000 +0000
@@ -1,9 +1,32 @@
-continuity (0.0~git20200107.26c1120-1fakesync1) groovy; urgency=medium
+continuity (0.0~git20201119.04c754f-2) unstable; urgency=medium
 
-  * Fake sync to work around accidental deletion of source package from
-    proposed.
+  * Team upload.
+  * Fix building on arm64
 
- -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Wed, 22 Jul 2020 12:09:21 +1200
+ -- Shengjing Zhu <zhsj@debian.org>  Thu, 26 Nov 2020 11:10:49 +0800
+
+continuity (0.0~git20201119.04c754f-1) unstable; urgency=medium
+
+  * Team upload.
+  * New upstream version 0.0~git20201119.04c754f
+  * Update Section to golang
+  * Update Standards-Version to 4.5.1 (no changes)
+
+ -- Shengjing Zhu <zhsj@debian.org>  Thu, 26 Nov 2020 01:48:10 +0800
+
+continuity (0.0~git20200710.efbc448-1) unstable; urgency=medium
+
+  * Team upload.
+
+  [ Debian Janitor ]
+  * Set upstream metadata fields: Bug-Database, Bug-Submit.
+  * Update standards version to 4.5.0, no changes needed.
+
+  [ Shengjing Zhu ]
+  * New upstream version 0.0~git20200710.efbc448
+  * Update debhelper compat to 13
+
+ -- Shengjing Zhu <zhsj@debian.org>  Sun, 23 Aug 2020 21:59:54 +0800
 
 continuity (0.0~git20200107.26c1120-1) unstable; urgency=medium
 
diff -pruN 0.0~git20200107.26c1120-1fakesync1/debian/control 0.0~git20201119.04c754f-2/debian/control
--- 0.0~git20200107.26c1120-1fakesync1/debian/control	2020-01-15 19:26:51.000000000 +0000
+++ 0.0~git20201119.04c754f-2/debian/control	2020-11-26 03:10:49.000000000 +0000
@@ -1,9 +1,9 @@
 Source: continuity
-Section: admin
+Section: golang
 Priority: optional
 Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
 Uploaders: Arnaud Rebillout <arnaud.rebillout@collabora.com>,
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                dh-golang,
                golang-any,
                golang-github-opencontainers-go-digest-dev,
@@ -12,7 +12,7 @@ Build-Depends: debhelper-compat (= 12),
                golang-golang-x-sync-dev,
                golang-golang-x-sys-dev (>= 0.0~git20180308~),
                golang-goprotobuf-dev,
-Standards-Version: 4.4.1
+Standards-Version: 4.5.1
 Homepage: https://github.com/containerd/continuity
 Vcs-Browser: https://salsa.debian.org/go-team/packages/continuity
 Vcs-Git: https://salsa.debian.org/go-team/packages/continuity.git
diff -pruN 0.0~git20200107.26c1120-1fakesync1/debian/docs 0.0~git20201119.04c754f-2/debian/docs
--- 0.0~git20200107.26c1120-1fakesync1/debian/docs	1970-01-01 00:00:00.000000000 +0000
+++ 0.0~git20201119.04c754f-2/debian/docs	2020-11-26 03:10:49.000000000 +0000
@@ -0,0 +1 @@
+README.md
diff -pruN 0.0~git20200107.26c1120-1fakesync1/debian/golang-github-containerd-continuity-dev.docs 0.0~git20201119.04c754f-2/debian/golang-github-containerd-continuity-dev.docs
--- 0.0~git20200107.26c1120-1fakesync1/debian/golang-github-containerd-continuity-dev.docs	2020-01-15 19:26:51.000000000 +0000
+++ 0.0~git20201119.04c754f-2/debian/golang-github-containerd-continuity-dev.docs	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-README.md
diff -pruN 0.0~git20200107.26c1120-1fakesync1/debian/patches/0001-Fix-building-on-arm64.patch 0.0~git20201119.04c754f-2/debian/patches/0001-Fix-building-on-arm64.patch
--- 0.0~git20200107.26c1120-1fakesync1/debian/patches/0001-Fix-building-on-arm64.patch	1970-01-01 00:00:00.000000000 +0000
+++ 0.0~git20201119.04c754f-2/debian/patches/0001-Fix-building-on-arm64.patch	2020-11-26 03:10:49.000000000 +0000
@@ -0,0 +1,33 @@
+From: Shengjing Zhu <zhsj@debian.org>
+Date: Thu, 26 Nov 2020 10:07:36 +0800
+Subject: Fix building on arm64
+
+Origin: backport, https://github.com/containerd/continuity/pull/165
+---
+ fs/du_unix.go | 6 ++++--
+ 1 file changed, 4 insertions(+), 2 deletions(-)
+
+diff --git a/fs/du_unix.go b/fs/du_unix.go
+index 76353c0..7cd8644 100644
+--- a/fs/du_unix.go
++++ b/fs/du_unix.go
+@@ -63,7 +63,8 @@ func diskUsage(ctx context.Context, roots ...string) (Usage, error) {
+ 			inoKey := newInode(stat)
+ 			if _, ok := inodes[inoKey]; !ok {
+ 				inodes[inoKey] = struct{}{}
+-				size += stat.Blocks * stat.Blksize
++				// on arm64 stat.Blksize is int32
++				size += stat.Blocks * int64(stat.Blksize) // nolint: unconvert
+ 			}
+ 
+ 			return nil
+@@ -94,7 +95,8 @@ func diffUsage(ctx context.Context, a, b string) (Usage, error) {
+ 			inoKey := newInode(stat)
+ 			if _, ok := inodes[inoKey]; !ok {
+ 				inodes[inoKey] = struct{}{}
+-				size += stat.Blocks * stat.Blksize
++				// on arm64 stat.Blksize is int32
++				size += stat.Blocks * int64(stat.Blksize) // nolint: unconvert
+ 			}
+ 
+ 			return nil
diff -pruN 0.0~git20200107.26c1120-1fakesync1/debian/patches/series 0.0~git20201119.04c754f-2/debian/patches/series
--- 0.0~git20200107.26c1120-1fakesync1/debian/patches/series	1970-01-01 00:00:00.000000000 +0000
+++ 0.0~git20201119.04c754f-2/debian/patches/series	2020-11-26 03:10:49.000000000 +0000
@@ -0,0 +1 @@
+0001-Fix-building-on-arm64.patch
diff -pruN 0.0~git20200107.26c1120-1fakesync1/debian/upstream/metadata 0.0~git20201119.04c754f-2/debian/upstream/metadata
--- 0.0~git20200107.26c1120-1fakesync1/debian/upstream/metadata	1970-01-01 00:00:00.000000000 +0000
+++ 0.0~git20201119.04c754f-2/debian/upstream/metadata	2020-11-26 03:10:49.000000000 +0000
@@ -0,0 +1,3 @@
+---
+Bug-Database: https://github.com/containerd/continuity/issues
+Bug-Submit: https://github.com/containerd/continuity/issues/new
diff -pruN 0.0~git20200107.26c1120-1fakesync1/devices/devices_unix.go 0.0~git20201119.04c754f-2/devices/devices_unix.go
--- 0.0~git20200107.26c1120-1fakesync1/devices/devices_unix.go	2020-01-07 19:41:36.000000000 +0000
+++ 0.0~git20201119.04c754f-2/devices/devices_unix.go	2020-11-19 17:31:50.000000000 +0000
@@ -32,6 +32,7 @@ func DeviceInfo(fi os.FileInfo) (uint64,
 		return 0, 0, fmt.Errorf("cannot extract device from os.FileInfo")
 	}
 
+	//nolint:unconvert
 	dev := uint64(sys.Rdev)
 	return uint64(unix.Major(dev)), uint64(unix.Minor(dev)), nil
 }
diff -pruN 0.0~git20200107.26c1120-1fakesync1/digests.go 0.0~git20201119.04c754f-2/digests.go
--- 0.0~git20200107.26c1120-1fakesync1/digests.go	2020-01-07 19:41:36.000000000 +0000
+++ 0.0~git20201119.04c754f-2/digests.go	2020-11-19 17:31:50.000000000 +0000
@@ -88,13 +88,9 @@ func digestsMatch(as, bs []digest.Digest
 	}
 
 	disjoint := len(as) + len(bs)
-	if len(uniqified) == disjoint {
-		// if these two sets have the same cardinality, we know both sides
-		// didn't share any digests.
-		return false
-	}
-
-	return true
+	// if these two sets have the same cardinality, we know both sides
+	// didn't share any digests.
+	return len(uniqified) != disjoint
 }
 
 type digestSlice []digest.Digest
diff -pruN 0.0~git20200107.26c1120-1fakesync1/driver/driver.go 0.0~git20201119.04c754f-2/driver/driver.go
--- 0.0~git20200107.26c1120-1fakesync1/driver/driver.go	2020-01-07 19:41:36.000000000 +0000
+++ 0.0~git20201119.04c754f-2/driver/driver.go	2020-11-19 17:31:50.000000000 +0000
@@ -138,6 +138,10 @@ func (d *driver) Lstat(p string) (os.Fil
 	return os.Lstat(p)
 }
 
+func (d *driver) Readlink(p string) (string, error) {
+	return os.Readlink(p)
+}
+
 func (d *driver) Mkdir(p string, mode os.FileMode) error {
 	return os.Mkdir(p, mode)
 }
diff -pruN 0.0~git20200107.26c1120-1fakesync1/driver/driver_unix.go 0.0~git20201119.04c754f-2/driver/driver_unix.go
--- 0.0~git20200107.26c1120-1fakesync1/driver/driver_unix.go	2020-01-07 19:41:36.000000000 +0000
+++ 0.0~git20201119.04c754f-2/driver/driver_unix.go	2020-11-19 17:31:50.000000000 +0000
@@ -131,8 +131,3 @@ func (d *driver) LSetxattr(path string,
 func (d *driver) DeviceInfo(fi os.FileInfo) (maj uint64, min uint64, err error) {
 	return devices.DeviceInfo(fi)
 }
-
-// Readlink was forked on Windows to fix a Golang bug, use the "os" package here
-func (d *driver) Readlink(p string) (string, error) {
-	return os.Readlink(p)
-}
diff -pruN 0.0~git20200107.26c1120-1fakesync1/driver/driver_windows.go 0.0~git20201119.04c754f-2/driver/driver_windows.go
--- 0.0~git20200107.26c1120-1fakesync1/driver/driver_windows.go	2020-01-07 19:41:36.000000000 +0000
+++ 0.0~git20201119.04c754f-2/driver/driver_windows.go	2020-11-19 17:31:50.000000000 +0000
@@ -1,3 +1,5 @@
+// +build go1.13
+
 /*
    Copyright The containerd Authors.
 
@@ -14,12 +16,14 @@
    limitations under the License.
 */
 
+// Go 1.13 is the minimally supported version for Windows.
+// Earlier golang releases have bug in os.Readlink
+// (see https://github.com/golang/go/issues/30463).
+
 package driver
 
 import (
 	"os"
-
-	"github.com/containerd/continuity/sysx"
 )
 
 func (d *driver) Mknod(path string, mode os.FileMode, major, minor int) error {
@@ -35,9 +39,3 @@ func (d *driver) Lchmod(path string, mod
 	// TODO: Use Window's equivalent
 	return os.Chmod(path, mode)
 }
-
-// Readlink is forked in order to support Volume paths which are used
-// in container layers.
-func (d *driver) Readlink(p string) (string, error) {
-	return sysx.Readlink(p)
-}
diff -pruN 0.0~git20200107.26c1120-1fakesync1/fs/copy_linux_test.go 0.0~git20201119.04c754f-2/fs/copy_linux_test.go
--- 0.0~git20200107.26c1120-1fakesync1/fs/copy_linux_test.go	2020-01-07 19:41:36.000000000 +0000
+++ 0.0~git20201119.04c754f-2/fs/copy_linux_test.go	2020-11-19 17:31:50.000000000 +0000
@@ -20,11 +20,11 @@ package fs
 
 import (
 	"io"
-	"path/filepath"
-	"math/rand"
 	"io/ioutil"
+	"math/rand"
 	"os"
 	"os/exec"
+	"path/filepath"
 	"testing"
 
 	"github.com/containerd/continuity/testutil"
@@ -59,7 +59,7 @@ func TestCopyReflinkWithXFS(t *testing.T
 	}
 	unmounted := false
 	defer func() {
-		if !unmounted{
+		if !unmounted {
 			testutil.Unmount(t, mnt)
 		}
 		loop.Close()
diff -pruN 0.0~git20200107.26c1120-1fakesync1/fs/diff_test.go 0.0~git20201119.04c754f-2/fs/diff_test.go
--- 0.0~git20200107.26c1120-1fakesync1/fs/diff_test.go	2020-01-07 19:41:36.000000000 +0000
+++ 0.0~git20201119.04c754f-2/fs/diff_test.go	2020-11-19 17:31:50.000000000 +0000
@@ -72,6 +72,22 @@ func TestSimpleDiff(t *testing.T) {
 	}
 }
 
+func TestEmptyFileDiff(t *testing.T) {
+	skipDiffTestOnWindows(t)
+	tt := time.Now().Truncate(time.Second)
+	l1 := fstest.Apply(
+		fstest.CreateDir("/etc", 0755),
+		fstest.CreateFile("/etc/empty", []byte(""), 0644),
+		fstest.Chtimes("/etc/empty", tt, tt),
+	)
+	l2 := fstest.Apply()
+	diff := []TestChange{}
+
+	if err := testDiffWithBase(l1, l2, diff); err != nil {
+		t.Fatalf("Failed diff with base: %+v", err)
+	}
+}
+
 func TestNestedDeletion(t *testing.T) {
 	skipDiffTestOnWindows(t)
 	l1 := fstest.Apply(
diff -pruN 0.0~git20200107.26c1120-1fakesync1/fs/du_unix.go 0.0~git20201119.04c754f-2/fs/du_unix.go
--- 0.0~git20200107.26c1120-1fakesync1/fs/du_unix.go	2020-01-07 19:41:36.000000000 +0000
+++ 0.0~git20201119.04c754f-2/fs/du_unix.go	2020-11-19 17:31:50.000000000 +0000
@@ -59,10 +59,11 @@ func diskUsage(ctx context.Context, root
 			default:
 			}
 
-			inoKey := newInode(fi.Sys().(*syscall.Stat_t))
+			stat := fi.Sys().(*syscall.Stat_t)
+			inoKey := newInode(stat)
 			if _, ok := inodes[inoKey]; !ok {
 				inodes[inoKey] = struct{}{}
-				size += fi.Size()
+				size += stat.Blocks * stat.Blksize
 			}
 
 			return nil
@@ -89,10 +90,11 @@ func diffUsage(ctx context.Context, a, b
 		}
 
 		if kind == ChangeKindAdd || kind == ChangeKindModify {
-			inoKey := newInode(fi.Sys().(*syscall.Stat_t))
+			stat := fi.Sys().(*syscall.Stat_t)
+			inoKey := newInode(stat)
 			if _, ok := inodes[inoKey]; !ok {
 				inodes[inoKey] = struct{}{}
-				size += fi.Size()
+				size += stat.Blocks * stat.Blksize
 			}
 
 			return nil
diff -pruN 0.0~git20200107.26c1120-1fakesync1/fs/fstest/continuity_util.go 0.0~git20201119.04c754f-2/fs/fstest/continuity_util.go
--- 0.0~git20200107.26c1120-1fakesync1/fs/fstest/continuity_util.go	2020-01-07 19:41:36.000000000 +0000
+++ 0.0~git20201119.04c754f-2/fs/fstest/continuity_util.go	2020-11-19 17:31:50.000000000 +0000
@@ -47,7 +47,7 @@ func (l resourceListDifference) HasDiff(
 	}
 
 	for _, add := range l.Additions {
-		if ok, _ := metadataFiles[add.Path()]; !ok {
+		if ok := metadataFiles[add.Path()]; !ok {
 			return true
 		}
 	}
@@ -66,7 +66,7 @@ func (l resourceListDifference) String()
 	for _, upt := range l.Updates {
 		fmt.Fprintf(buf, "~ %s\n", upt.String())
 	}
-	return string(buf.Bytes())
+	return buf.String()
 }
 
 // diffManifest compares two resource lists and returns the list
diff -pruN 0.0~git20200107.26c1120-1fakesync1/fs/fstest/testsuite.go 0.0~git20201119.04c754f-2/fs/fstest/testsuite.go
--- 0.0~git20200107.26c1120-1fakesync1/fs/fstest/testsuite.go	2020-01-07 19:41:36.000000000 +0000
+++ 0.0~git20201119.04c754f-2/fs/fstest/testsuite.go	2020-11-19 17:31:50.000000000 +0000
@@ -210,7 +210,7 @@ var (
 	}
 
 	// Hardlink name before with modification
-	// Tests link is created for unmodified files when new hardlinked file is seen first
+	// Tests link is created for unmodified files when a new hard linked file is seen first
 	hardlinkBeforeUnmodified = []Applier{
 		baseApplier,
 		Apply(
diff -pruN 0.0~git20200107.26c1120-1fakesync1/fs/path.go 0.0~git20201119.04c754f-2/fs/path.go
--- 0.0~git20200107.26c1120-1fakesync1/fs/path.go	2020-01-07 19:41:36.000000000 +0000
+++ 0.0~git20201119.04c754f-2/fs/path.go	2020-11-19 17:31:50.000000000 +0000
@@ -117,15 +117,13 @@ func sameFile(f1, f2 *currentPath) (bool
 		// If the timestamp may have been truncated in both of the
 		// files, check content of file to determine difference
 		if t1.Nanosecond() == 0 && t2.Nanosecond() == 0 {
-			var eq bool
 			if (f1.f.Mode() & os.ModeSymlink) == os.ModeSymlink {
-				eq, err = compareSymlinkTarget(f1.fullPath, f2.fullPath)
-			} else if f1.f.Size() > 0 {
-				eq, err = compareFileContent(f1.fullPath, f2.fullPath)
+				return compareSymlinkTarget(f1.fullPath, f2.fullPath)
 			}
-			if err != nil || !eq {
-				return eq, err
+			if f1.f.Size() == 0 { // if file sizes are zero length, the files are the same by definition
+				return true, nil
 			}
+			return compareFileContent(f1.fullPath, f2.fullPath)
 		} else if t1.Nanosecond() != t2.Nanosecond() {
 			return false, nil
 		}
diff -pruN 0.0~git20200107.26c1120-1fakesync1/.github/workflows/ci.yml 0.0~git20201119.04c754f-2/.github/workflows/ci.yml
--- 0.0~git20200107.26c1120-1fakesync1/.github/workflows/ci.yml	1970-01-01 00:00:00.000000000 +0000
+++ 0.0~git20201119.04c754f-2/.github/workflows/ci.yml	2020-11-19 17:31:50.000000000 +0000
@@ -0,0 +1,90 @@
+name: Continuity
+
+on:
+  push:
+    branches: [ master ]
+  pull_request:
+    branches: [ master ]
+
+jobs:
+
+  #
+  # Project checks
+  #
+  project:
+    name: Project Checks
+    runs-on: ubuntu-18.04
+    timeout-minutes: 5
+
+    steps:
+      - uses: actions/checkout@v2
+        with:
+          path: src/github.com/containerd/continuity
+          fetch-depth: 100
+
+      - uses: containerd/project-checks@v1
+        with:
+          working-directory: src/github.com/containerd/continuity
+
+  tests:
+    name: CI Tests
+    runs-on: ${{ matrix.os }}
+    timeout-minutes: 10
+    needs: [checks]
+
+    strategy:
+      matrix:
+        os: [ubuntu-18.04, macos-10.15, windows-2019]
+
+    steps:
+    - name: Set up Go
+      uses: actions/setup-go@v1
+      with:
+        go-version: 1.15
+
+    - name: Setup Go binary path
+      shell: bash
+      run: |
+        echo "GOPATH=${{ github.workspace }}" >> $GITHUB_ENV
+        echo "${{ github.workspace }}/bin" >> $GITHUB_PATH
+
+    - name: Git line endings
+      shell: bash
+      run: |
+        git config --global core.autocrlf false
+        git config --global core.eol lf
+
+    - name: Check out code
+      uses: actions/checkout@v2
+      with:
+        path: src/github.com/containerd/continuity
+        fetch-depth: 25
+
+    - name: Dependencies
+      env:
+        GO111MODULE: on
+      shell: bash
+      run: go get github.com/golangci/golangci-lint/cmd/golangci-lint@v1.23.8
+
+    - name: Lint
+      shell: bash
+      run: make lint
+      working-directory: src/github.com/containerd/continuity
+
+    - name: Build
+      shell: bash
+      run: make build binaries
+      working-directory: src/github.com/containerd/continuity
+
+    - name: Linux Tests
+      if: startsWith(matrix.os, 'ubuntu')
+      run: |
+        make test
+        sudo GOPATH=$GOPATH make root-test
+      working-directory: src/github.com/containerd/continuity
+
+    - name: Non-Linux Tests
+      if: ${{ !startsWith(matrix.os, 'ubuntu') }}
+      shell: bash
+      run: make test-compile
+      working-directory: src/github.com/containerd/continuity
diff -pruN 0.0~git20200107.26c1120-1fakesync1/.golangci.yml 0.0~git20201119.04c754f-2/.golangci.yml
--- 0.0~git20200107.26c1120-1fakesync1/.golangci.yml	1970-01-01 00:00:00.000000000 +0000
+++ 0.0~git20201119.04c754f-2/.golangci.yml	2020-11-19 17:31:50.000000000 +0000
@@ -0,0 +1,18 @@
+linters:
+  enable:
+    - structcheck
+    - varcheck
+    - staticcheck
+    - unconvert
+    - gofmt
+    - goimports
+    - golint
+    - ineffassign
+    - vet
+    - unused
+    - misspell
+  disable:
+    - errcheck
+
+run:
+  timeout: 3m
diff -pruN 0.0~git20200107.26c1120-1fakesync1/go.mod 0.0~git20201119.04c754f-2/go.mod
--- 0.0~git20200107.26c1120-1fakesync1/go.mod	2020-01-07 19:41:36.000000000 +0000
+++ 0.0~git20201119.04c754f-2/go.mod	2020-11-19 17:31:50.000000000 +0000
@@ -1,23 +1,19 @@
 module github.com/containerd/continuity
 
-go 1.11
+go 1.13
 
 require (
 	bazil.org/fuse v0.0.0-20160811212531-371fbbdaa898
-	github.com/dustin/go-humanize v0.0.0-20171111073723-bb3d318650d4
+	github.com/dustin/go-humanize v1.0.0
 	github.com/golang/protobuf v1.2.0
 	github.com/inconshreveable/mousetrap v1.0.0 // indirect
-	github.com/onsi/ginkgo v1.10.1 // indirect
-	github.com/onsi/gomega v1.7.0 // indirect
-	github.com/opencontainers/go-digest v1.0.0-rc1
-	github.com/pkg/errors v0.8.1-0.20171018195549-f15c970de5b7
-	github.com/sirupsen/logrus v1.0.4-0.20170822132746-89742aefa4b2
+	github.com/opencontainers/go-digest v1.0.0
+	github.com/pkg/errors v0.9.1
+	github.com/sirupsen/logrus v1.6.0
 	github.com/spf13/cobra v0.0.2-0.20171109065643-2da4a54c5cee
 	github.com/spf13/pflag v1.0.1-0.20171106142849-4c012f6dcd95 // indirect
 	github.com/stretchr/testify v1.4.0 // indirect
-	golang.org/x/crypto v0.0.0-20171113213409-9f005a07e0d3 // indirect
+	golang.org/x/net v0.0.0-20180906233101-161cd47e91fd // indirect
 	golang.org/x/sync v0.0.0-20180314180146-1d60e4601c6f
-	golang.org/x/sys v0.0.0-20180909124046-d0be0721c37e
-	gopkg.in/airbrake/gobrake.v2 v2.0.9 // indirect
-	gopkg.in/gemnasium/logrus-airbrake-hook.v2 v2.1.2 // indirect
+	golang.org/x/sys v0.0.0-20190422165155-953cdadca894
 )
diff -pruN 0.0~git20200107.26c1120-1fakesync1/go.sum 0.0~git20201119.04c754f-2/go.sum
--- 0.0~git20200107.26c1120-1fakesync1/go.sum	2020-01-07 19:41:36.000000000 +0000
+++ 0.0~git20201119.04c754f-2/go.sum	2020-11-19 17:31:50.000000000 +0000
@@ -2,56 +2,39 @@ bazil.org/fuse v0.0.0-20160811212531-371
 bazil.org/fuse v0.0.0-20160811212531-371fbbdaa898/go.mod h1:Xbm+BRKSBEpa4q4hTSxohYNQpsxXPbPry4JJWOB3LB8=
 github.com/davecgh/go-spew v1.1.0 h1:ZDRjVQ15GmhC3fiQ8ni8+OwkZQO4DARzQgrnXU1Liz8=
 github.com/davecgh/go-spew v1.1.0/go.mod h1:J7Y8YcW2NihsgmVo/mv3lAwl/skON4iLHjSsI+c5H38=
-github.com/dustin/go-humanize v0.0.0-20171111073723-bb3d318650d4 h1:qk/FSDDxo05wdJH28W+p5yivv7LuLYLRXPPD8KQCtZs=
-github.com/dustin/go-humanize v0.0.0-20171111073723-bb3d318650d4/go.mod h1:HtrtbFcZ19U5GC7JDqmcUSB87Iq5E25KnS6fMYU6eOk=
-github.com/fsnotify/fsnotify v1.4.7 h1:IXs+QLmnXW2CcXuY+8Mzv/fWEsPGWxqefPtCP5CnV9I=
-github.com/fsnotify/fsnotify v1.4.7/go.mod h1:jwhsz4b93w/PPRr/qN1Yymfu8t87LnFCMoQvtojpjFo=
+github.com/davecgh/go-spew v1.1.1 h1:vj9j/u1bqnvCEfJOwUhtlOARqs3+rkHYY13jYWTU97c=
+github.com/davecgh/go-spew v1.1.1/go.mod h1:J7Y8YcW2NihsgmVo/mv3lAwl/skON4iLHjSsI+c5H38=
+github.com/dustin/go-humanize v1.0.0 h1:VSnTsYCnlFHaM2/igO1h6X3HA71jcobQuxemgkq4zYo=
+github.com/dustin/go-humanize v1.0.0/go.mod h1:HtrtbFcZ19U5GC7JDqmcUSB87Iq5E25KnS6fMYU6eOk=
 github.com/golang/protobuf v1.2.0 h1:P3YflyNX/ehuJFLhxviNdFxQPkGK5cDcApsge1SqnvM=
 github.com/golang/protobuf v1.2.0/go.mod h1:6lQm79b+lXiMfvg/cZm0SGofjICqVBUtrP5yJMmIC1U=
-github.com/hpcloud/tail v1.0.0 h1:nfCOvKYfkgYP8hkirhJocXT2+zOD8yUNjXaWfTlyFKI=
-github.com/hpcloud/tail v1.0.0/go.mod h1:ab1qPbhIpdTxEkNHXyeSf5vhxWSCs/tWer42PpOxQnU=
 github.com/inconshreveable/mousetrap v1.0.0 h1:Z8tu5sraLXCXIcARxBp/8cbvlwVa7Z1NHg9XEKhtSvM=
 github.com/inconshreveable/mousetrap v1.0.0/go.mod h1:PxqpIevigyE2G7u3NXJIT2ANytuPF1OarO4DADm73n8=
-github.com/onsi/ginkgo v1.6.0/go.mod h1:lLunBs/Ym6LB5Z9jYTR76FiuTmxDTDusOGeTQH+WWjE=
-github.com/onsi/ginkgo v1.10.1 h1:q/mM8GF/n0shIN8SaAZ0V+jnLPzen6WIVZdiwrRlMlo=
-github.com/onsi/ginkgo v1.10.1/go.mod h1:lLunBs/Ym6LB5Z9jYTR76FiuTmxDTDusOGeTQH+WWjE=
-github.com/onsi/gomega v1.7.0 h1:XPnZz8VVBHjVsy1vzJmRwIcSwiUO+JFfrv/xGiigmME=
-github.com/onsi/gomega v1.7.0/go.mod h1:ex+gbHU/CVuBBDIJjb2X0qEXbFg53c61hWP/1CpauHY=
-github.com/opencontainers/go-digest v1.0.0-rc1 h1:WzifXhOVOEOuFYOJAW6aQqW0TooG2iki3E3Ii+WN7gQ=
-github.com/opencontainers/go-digest v1.0.0-rc1/go.mod h1:cMLVZDEM3+U2I4VmLI6N8jQYUd2OVphdqWwCJHrFt2s=
-github.com/pkg/errors v0.8.1-0.20171018195549-f15c970de5b7 h1:RcqIXZDN7Vz5lgK7+0h3MFF2JNgEu4h91palXJLJ354=
-github.com/pkg/errors v0.8.1-0.20171018195549-f15c970de5b7/go.mod h1:bwawxfHBFNV+L2hUp1rHADufV3IMtnDRdf1r5NINEl0=
+github.com/konsorten/go-windows-terminal-sequences v1.0.3 h1:CE8S1cTafDpPvMhIxNJKvHsGVBgn1xWYf1NbHQhywc8=
+github.com/konsorten/go-windows-terminal-sequences v1.0.3/go.mod h1:T0+1ngSBFLxvqU3pZ+m/2kptfBszLMUkC4ZK/EgS/cQ=
+github.com/opencontainers/go-digest v1.0.0 h1:apOUWs51W5PlhuyGyz9FCeeBIOUDA/6nW8Oi/yOhh5U=
+github.com/opencontainers/go-digest v1.0.0/go.mod h1:0JzlMkj0TRzQZfJkVvzbP0HBR3IKzErnv2BNG4W4MAM=
+github.com/pkg/errors v0.9.1 h1:FEBLx1zS214owpjy7qsBeixbURkuhQAwrK5UwLGTwt4=
+github.com/pkg/errors v0.9.1/go.mod h1:bwawxfHBFNV+L2hUp1rHADufV3IMtnDRdf1r5NINEl0=
 github.com/pmezard/go-difflib v1.0.0 h1:4DBwDE0NGyQoBHbLQYPwSUPoCMWR5BEzIk/f1lZbAQM=
 github.com/pmezard/go-difflib v1.0.0/go.mod h1:iKH77koFhYxTK1pcRnkKkqfTogsbg7gZNVY4sRDYZ/4=
-github.com/sirupsen/logrus v1.0.4-0.20170822132746-89742aefa4b2 h1:a07zp0wovcAE2jH+wlD22JLqUH6Rdl8Aon+NiyPxE+0=
-github.com/sirupsen/logrus v1.0.4-0.20170822132746-89742aefa4b2/go.mod h1:pMByvHTf9Beacp5x1UXfOR9xyW/9antXMhjMPG0dEzc=
+github.com/sirupsen/logrus v1.6.0 h1:UBcNElsrwanuuMsnGSlYmtmgbb23qDR5dG+6X6Oo89I=
+github.com/sirupsen/logrus v1.6.0/go.mod h1:7uNnSEd1DgxDLC74fIahvMZmmYsHGZGEOFrfsX/uA88=
 github.com/spf13/cobra v0.0.2-0.20171109065643-2da4a54c5cee h1:GQkkv3XSnxhAMjdq2wLfEnptEVr+2BNvmHizILHn+d4=
 github.com/spf13/cobra v0.0.2-0.20171109065643-2da4a54c5cee/go.mod h1:1l0Ry5zgKvJasoi3XT1TypsSe7PqH0Sj9dhYf7v3XqQ=
 github.com/spf13/pflag v1.0.1-0.20171106142849-4c012f6dcd95 h1:j8jxLbQ0+T1DFggy6XoGvyUnrJWPR/JybflPvu5rwS4=
 github.com/spf13/pflag v1.0.1-0.20171106142849-4c012f6dcd95/go.mod h1:DYY7MBk1bdzusC3SYhjObp+wFpr4gzcvqqNjLnInEg4=
 github.com/stretchr/objx v0.1.0/go.mod h1:HFkY916IF+rwdDfMAkV7OtwuqBVzrE8GR6GFx+wExME=
+github.com/stretchr/testify v1.2.2/go.mod h1:a8OnRcib4nhh0OaRAV+Yts87kKdq0PP7pXfy6kDkUVs=
 github.com/stretchr/testify v1.4.0 h1:2E4SXV/wtOkTonXsotYi4li6zVWxYlZuYNCXe9XRJyk=
 github.com/stretchr/testify v1.4.0/go.mod h1:j7eGeouHqKxXV5pUuKE4zz7dFj8WfuZ+81PSLYec5m4=
-golang.org/x/crypto v0.0.0-20171113213409-9f005a07e0d3 h1:f4/ZD59VsBOaJmWeI2yqtHvJhmRRPzi73C88ZtfhAIk=
-golang.org/x/crypto v0.0.0-20171113213409-9f005a07e0d3/go.mod h1:6SG95UA2DQfeDnfUPMdvaQW0Q7yPrPDi9nlGo2tz2b4=
 golang.org/x/net v0.0.0-20180906233101-161cd47e91fd h1:nTDtHvHSdCn1m6ITfMRqtOd/9+7a3s8RBNOZ3eYZzJA=
 golang.org/x/net v0.0.0-20180906233101-161cd47e91fd/go.mod h1:mL1N/T3taQHkDXs73rZJwtUhF3w3ftmwwsq0BUmARs4=
 golang.org/x/sync v0.0.0-20180314180146-1d60e4601c6f h1:wMNYb4v58l5UBM7MYRLPG6ZhfOqbKu7X5eyFl8ZhKvA=
 golang.org/x/sync v0.0.0-20180314180146-1d60e4601c6f/go.mod h1:RxMgew5VJxzue5/jJTE5uejpjVlOe/izrB70Jof72aM=
-golang.org/x/sys v0.0.0-20180909124046-d0be0721c37e h1:o3PsSEY8E4eXWkXrIP9YJALUkVZqzHJT5DOasTyn8Vs=
-golang.org/x/sys v0.0.0-20180909124046-d0be0721c37e/go.mod h1:STP8DvDyc/dI5b8T5hshtkjS+E42TnysNCUPdjciGhY=
-golang.org/x/text v0.3.0 h1:g61tztE5qeGQ89tm6NTjjM9VPIm088od1l6aSorWRWg=
-golang.org/x/text v0.3.0/go.mod h1:NqM8EUOU14njkJ3fqMW+pc6Ldnwhi/IjpwHt7yyuwOQ=
-gopkg.in/airbrake/gobrake.v2 v2.0.9 h1:7z2uVWwn7oVeeugY1DtlPAy5H+KYgB1KeKTnqjNatLo=
-gopkg.in/airbrake/gobrake.v2 v2.0.9/go.mod h1:/h5ZAUhDkGaJfjzjKLSjv6zCL6O0LLBxU4K+aSYdM/U=
+golang.org/x/sys v0.0.0-20190422165155-953cdadca894 h1:Cz4ceDQGXuKRnVBDTS23GTn/pU5OE2C0WrNTOYK1Uuc=
+golang.org/x/sys v0.0.0-20190422165155-953cdadca894/go.mod h1:h1NjWce9XRLGQEsW7wpKNCjG9DtNlClVuFLEZdDNbEs=
 gopkg.in/check.v1 v0.0.0-20161208181325-20d25e280405 h1:yhCVgyC4o1eVCa2tZl7eS0r+SDo693bJlVdllGtEeKM=
 gopkg.in/check.v1 v0.0.0-20161208181325-20d25e280405/go.mod h1:Co6ibVJAznAaIkqp8huTwlJQCZ016jof/cbN4VW5Yz0=
-gopkg.in/fsnotify.v1 v1.4.7 h1:xOHLXZwVvI9hhs+cLKq5+I5onOuwQLhQwiu63xxlHs4=
-gopkg.in/fsnotify.v1 v1.4.7/go.mod h1:Tz8NjZHkW78fSQdbUxIjBTcgA1z1m8ZHf0WmKUhAMys=
-gopkg.in/gemnasium/logrus-airbrake-hook.v2 v2.1.2 h1:OAj3g0cR6Dx/R07QgQe8wkA9RNjB2u4i700xBkIT4e0=
-gopkg.in/gemnasium/logrus-airbrake-hook.v2 v2.1.2/go.mod h1:Xk6kEKp8OKb+X14hQBKWaSkCsqBpgog8nAV2xsGOxlo=
-gopkg.in/tomb.v1 v1.0.0-20141024135613-dd632973f1e7 h1:uRGJdciOHaEIrze2W8Q3AKkepLTh2hOroT7a+7czfdQ=
-gopkg.in/tomb.v1 v1.0.0-20141024135613-dd632973f1e7/go.mod h1:dt/ZhP58zS4L8KSrWDmTeBkI65Dw0HsyUHuEVlX15mw=
-gopkg.in/yaml.v2 v2.2.1/go.mod h1:hI93XBmqTisBFMUTm0b8Fm+jr3Dg1NNxqwp+5A1VGuI=
 gopkg.in/yaml.v2 v2.2.2 h1:ZCJp+EgiOT7lHqUV2J862kp8Qj64Jo6az82+3Td9dZw=
 gopkg.in/yaml.v2 v2.2.2/go.mod h1:hI93XBmqTisBFMUTm0b8Fm+jr3Dg1NNxqwp+5A1VGuI=
diff -pruN 0.0~git20200107.26c1120-1fakesync1/groups_unix.go 0.0~git20201119.04c754f-2/groups_unix.go
--- 0.0~git20200107.26c1120-1fakesync1/groups_unix.go	2020-01-07 19:41:36.000000000 +0000
+++ 0.0~git20201119.04c754f-2/groups_unix.go	2020-11-19 17:31:50.000000000 +0000
@@ -14,6 +14,7 @@
    limitations under the License.
 */
 
+//nolint:unused,deadcode
 package continuity
 
 import (
diff -pruN 0.0~git20200107.26c1120-1fakesync1/hardlinks.go 0.0~git20201119.04c754f-2/hardlinks.go
--- 0.0~git20200107.26c1120-1fakesync1/hardlinks.go	2020-01-07 19:41:36.000000000 +0000
+++ 0.0~git20201119.04c754f-2/hardlinks.go	2020-11-19 17:31:50.000000000 +0000
@@ -53,7 +53,7 @@ func (hlm *hardlinkManager) Add(fi os.Fi
 }
 
 // Merge processes the current state of the hardlink manager and merges any
-// shared nodes into hardlinked resources.
+// shared nodes into hard linked resources.
 func (hlm *hardlinkManager) Merge() ([]Resource, error) {
 	var resources []Resource
 	for key, linked := range hlm.hardlinks {
diff -pruN 0.0~git20200107.26c1120-1fakesync1/hardlinks_unix.go 0.0~git20201119.04c754f-2/hardlinks_unix.go
--- 0.0~git20200107.26c1120-1fakesync1/hardlinks_unix.go	2020-01-07 19:41:36.000000000 +0000
+++ 0.0~git20201119.04c754f-2/hardlinks_unix.go	2020-11-19 17:31:50.000000000 +0000
@@ -48,5 +48,6 @@ func newHardlinkKey(fi os.FileInfo) (har
 		return hardlinkKey{}, errNotAHardLink
 	}
 
+	//nolint:unconvert
 	return hardlinkKey{dev: uint64(sys.Dev), inode: uint64(sys.Ino)}, nil
 }
diff -pruN 0.0~git20200107.26c1120-1fakesync1/ioutils_test.go 0.0~git20201119.04c754f-2/ioutils_test.go
--- 0.0~git20200107.26c1120-1fakesync1/ioutils_test.go	2020-01-07 19:41:36.000000000 +0000
+++ 0.0~git20201119.04c754f-2/ioutils_test.go	2020-11-19 17:31:50.000000000 +0000
@@ -41,7 +41,7 @@ func TestAtomicWriteFile(t *testing.T) {
 		t.Fatalf("Error reading from file: %v", err)
 	}
 
-	if bytes.Compare(actual, expected) != 0 {
+	if !bytes.Equal(actual, expected) {
 		t.Fatalf("Data mismatch, expected %q, got %q", expected, actual)
 	}
 
diff -pruN 0.0~git20200107.26c1120-1fakesync1/Makefile 0.0~git20201119.04c754f-2/Makefile
--- 0.0~git20200107.26c1120-1fakesync1/Makefile	2020-01-07 19:41:36.000000000 +0000
+++ 0.0~git20201119.04c754f-2/Makefile	2020-11-19 17:31:50.000000000 +0000
@@ -33,10 +33,10 @@ TEST_REQUIRES_ROOT_PACKAGES=$(filter \
     done | sort -u) \
     )
 
-.PHONY: clean all fmt vet lint build test binaries
+.PHONY: clean all lint build test binaries
 .DEFAULT: default
-# skip lint at the moment
-all: AUTHORS clean fmt vet fmt build test binaries
+
+all: AUTHORS clean lint build test binaries
 
 AUTHORS: .mailmap .git/HEAD
 	 git log --format='%aN <%aE>' | sort -fu > $@
@@ -52,20 +52,9 @@ ${PREFIX}/bin/continuity: version/versio
 generate:
 	go generate -mod=vendor $(PACKAGES)
 
-# Depends on binaries because vet will silently fail if it can't load compiled
-# imports
-vet: binaries
-	@echo "+ $@"
-	@go vet -mod=vendor $(PACKAGES)
-
-fmt:
-	@echo "+ $@"
-	@test -z "$$(gofmt -s -l . | grep -v Godeps/_workspace/src/ | grep -v vendor/ | tee /dev/stderr)" || \
-		echo "+ please format Go code with 'gofmt -s'"
-
 lint:
 	@echo "+ $@"
-	@test -z "$$(golint $(PACKAGES) | grep -v Godeps/_workspace/src/ | grep -v vendor/ |tee /dev/stderr)"
+	@golangci-lint run
 
 build:
 	@echo "+ $@"
diff -pruN 0.0~git20200107.26c1120-1fakesync1/manifest.go 0.0~git20201119.04c754f-2/manifest.go
--- 0.0~git20200107.26c1120-1fakesync1/manifest.go	2020-01-07 19:41:36.000000000 +0000
+++ 0.0~git20201119.04c754f-2/manifest.go	2020-11-19 17:31:50.000000000 +0000
@@ -114,11 +114,13 @@ func BuildManifest(ctx Context) (*Manife
 	}
 
 	// merge and post-process the hardlinks.
+	// nolint:misspell
 	hardlinked, err := hardlinks.Merge()
 	if err != nil {
 		return nil, err
 	}
 
+	// nolint:misspell
 	for _, resource := range hardlinked {
 		resourcesByPath[resource.Path()] = resource
 	}
diff -pruN 0.0~git20200107.26c1120-1fakesync1/manifest_test.go 0.0~git20201119.04c754f-2/manifest_test.go
--- 0.0~git20200107.26c1120-1fakesync1/manifest_test.go	2020-01-07 19:41:36.000000000 +0000
+++ 0.0~git20201119.04c754f-2/manifest_test.go	2020-11-19 17:31:50.000000000 +0000
@@ -120,7 +120,7 @@ func TestWalkFS(t *testing.T) {
 		// },
 
 		// TODO(stevvooe): Must add tests for xattrs, with symlinks,
-		// directorys and regular files.
+		// directories and regular files.
 
 		{
 			kind: rnamedpipe,
diff -pruN 0.0~git20200107.26c1120-1fakesync1/resource_test.go 0.0~git20201119.04c754f-2/resource_test.go
--- 0.0~git20200107.26c1120-1fakesync1/resource_test.go	2020-01-07 19:41:36.000000000 +0000
+++ 0.0~git20201119.04c754f-2/resource_test.go	2020-11-19 17:31:50.000000000 +0000
@@ -14,6 +14,7 @@
    limitations under the License.
 */
 
+//nolint:unused,deadcode
 package continuity
 
 type resourceUpdate struct {
diff -pruN 0.0~git20200107.26c1120-1fakesync1/syscallx/syscall_unix.go 0.0~git20201119.04c754f-2/syscallx/syscall_unix.go
--- 0.0~git20200107.26c1120-1fakesync1/syscallx/syscall_unix.go	2020-01-07 19:41:36.000000000 +0000
+++ 0.0~git20201119.04c754f-2/syscallx/syscall_unix.go	1970-01-01 00:00:00.000000000 +0000
@@ -1,26 +0,0 @@
-// +build !windows
-
-/*
-   Copyright The containerd Authors.
-
-   Licensed under the Apache License, Version 2.0 (the "License");
-   you may not use this file except in compliance with the License.
-   You may obtain a copy of the License at
-
-       http://www.apache.org/licenses/LICENSE-2.0
-
-   Unless required by applicable law or agreed to in writing, software
-   distributed under the License is distributed on an "AS IS" BASIS,
-   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
-   See the License for the specific language governing permissions and
-   limitations under the License.
-*/
-
-package syscallx
-
-import "syscall"
-
-// Readlink returns the destination of the named symbolic link.
-func Readlink(path string, buf []byte) (n int, err error) {
-	return syscall.Readlink(path, buf)
-}
diff -pruN 0.0~git20200107.26c1120-1fakesync1/syscallx/syscall_windows.go 0.0~git20201119.04c754f-2/syscallx/syscall_windows.go
--- 0.0~git20200107.26c1120-1fakesync1/syscallx/syscall_windows.go	2020-01-07 19:41:36.000000000 +0000
+++ 0.0~git20201119.04c754f-2/syscallx/syscall_windows.go	1970-01-01 00:00:00.000000000 +0000
@@ -1,112 +0,0 @@
-/*
-   Copyright The containerd Authors.
-
-   Licensed under the Apache License, Version 2.0 (the "License");
-   you may not use this file except in compliance with the License.
-   You may obtain a copy of the License at
-
-       http://www.apache.org/licenses/LICENSE-2.0
-
-   Unless required by applicable law or agreed to in writing, software
-   distributed under the License is distributed on an "AS IS" BASIS,
-   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
-   See the License for the specific language governing permissions and
-   limitations under the License.
-*/
-
-package syscallx
-
-import (
-	"syscall"
-	"unsafe"
-)
-
-type reparseDataBuffer struct {
-	ReparseTag        uint32
-	ReparseDataLength uint16
-	Reserved          uint16
-
-	// GenericReparseBuffer
-	reparseBuffer byte
-}
-
-type mountPointReparseBuffer struct {
-	SubstituteNameOffset uint16
-	SubstituteNameLength uint16
-	PrintNameOffset      uint16
-	PrintNameLength      uint16
-	PathBuffer           [1]uint16
-}
-
-type symbolicLinkReparseBuffer struct {
-	SubstituteNameOffset uint16
-	SubstituteNameLength uint16
-	PrintNameOffset      uint16
-	PrintNameLength      uint16
-	Flags                uint32
-	PathBuffer           [1]uint16
-}
-
-const (
-	_IO_REPARSE_TAG_MOUNT_POINT = 0xA0000003
-	_SYMLINK_FLAG_RELATIVE      = 1
-)
-
-// Readlink returns the destination of the named symbolic link.
-func Readlink(path string, buf []byte) (n int, err error) {
-	fd, err := syscall.CreateFile(syscall.StringToUTF16Ptr(path), syscall.GENERIC_READ, 0, nil, syscall.OPEN_EXISTING,
-		syscall.FILE_FLAG_OPEN_REPARSE_POINT|syscall.FILE_FLAG_BACKUP_SEMANTICS, 0)
-	if err != nil {
-		return -1, err
-	}
-	defer syscall.CloseHandle(fd)
-
-	rdbbuf := make([]byte, syscall.MAXIMUM_REPARSE_DATA_BUFFER_SIZE)
-	var bytesReturned uint32
-	err = syscall.DeviceIoControl(fd, syscall.FSCTL_GET_REPARSE_POINT, nil, 0, &rdbbuf[0], uint32(len(rdbbuf)), &bytesReturned, nil)
-	if err != nil {
-		return -1, err
-	}
-
-	rdb := (*reparseDataBuffer)(unsafe.Pointer(&rdbbuf[0]))
-	var s string
-	switch rdb.ReparseTag {
-	case syscall.IO_REPARSE_TAG_SYMLINK:
-		data := (*symbolicLinkReparseBuffer)(unsafe.Pointer(&rdb.reparseBuffer))
-		p := (*[0xffff]uint16)(unsafe.Pointer(&data.PathBuffer[0]))
-		s = syscall.UTF16ToString(p[data.SubstituteNameOffset/2 : (data.SubstituteNameOffset+data.SubstituteNameLength)/2])
-		if data.Flags&_SYMLINK_FLAG_RELATIVE == 0 {
-			if len(s) >= 4 && s[:4] == `\??\` {
-				s = s[4:]
-				switch {
-				case len(s) >= 2 && s[1] == ':': // \??\C:\foo\bar
-					// do nothing
-				case len(s) >= 4 && s[:4] == `UNC\`: // \??\UNC\foo\bar
-					s = `\\` + s[4:]
-				default:
-					// unexpected; do nothing
-				}
-			} else {
-				// unexpected; do nothing
-			}
-		}
-	case _IO_REPARSE_TAG_MOUNT_POINT:
-		data := (*mountPointReparseBuffer)(unsafe.Pointer(&rdb.reparseBuffer))
-		p := (*[0xffff]uint16)(unsafe.Pointer(&data.PathBuffer[0]))
-		s = syscall.UTF16ToString(p[data.SubstituteNameOffset/2 : (data.SubstituteNameOffset+data.SubstituteNameLength)/2])
-		if len(s) >= 4 && s[:4] == `\??\` { // \??\C:\foo\bar
-			if len(s) < 48 || s[:11] != `\??\Volume{` {
-				s = s[4:]
-			}
-		} else {
-			// unexpected; do nothing
-		}
-	default:
-		// the path is not a symlink or junction but another type of reparse
-		// point
-		return -1, syscall.ENOENT
-	}
-	n = copy(buf, []byte(s))
-
-	return n, nil
-}
diff -pruN 0.0~git20200107.26c1120-1fakesync1/sysx/file_posix.go 0.0~git20201119.04c754f-2/sysx/file_posix.go
--- 0.0~git20200107.26c1120-1fakesync1/sysx/file_posix.go	2020-01-07 19:41:36.000000000 +0000
+++ 0.0~git20201119.04c754f-2/sysx/file_posix.go	1970-01-01 00:00:00.000000000 +0000
@@ -1,128 +0,0 @@
-/*
-   Copyright The containerd Authors.
-
-   Licensed under the Apache License, Version 2.0 (the "License");
-   you may not use this file except in compliance with the License.
-   You may obtain a copy of the License at
-
-       http://www.apache.org/licenses/LICENSE-2.0
-
-   Unless required by applicable law or agreed to in writing, software
-   distributed under the License is distributed on an "AS IS" BASIS,
-   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
-   See the License for the specific language governing permissions and
-   limitations under the License.
-*/
-
-package sysx
-
-import (
-	"os"
-	"path/filepath"
-
-	"github.com/containerd/continuity/syscallx"
-)
-
-// Readlink returns the destination of the named symbolic link.
-// If there is an error, it will be of type *PathError.
-func Readlink(name string) (string, error) {
-	for len := 128; ; len *= 2 {
-		b := make([]byte, len)
-		n, e := fixCount(syscallx.Readlink(fixLongPath(name), b))
-		if e != nil {
-			return "", &os.PathError{Op: "readlink", Path: name, Err: e}
-		}
-		if n < len {
-			return string(b[0:n]), nil
-		}
-	}
-}
-
-// Many functions in package syscall return a count of -1 instead of 0.
-// Using fixCount(call()) instead of call() corrects the count.
-func fixCount(n int, err error) (int, error) {
-	if n < 0 {
-		n = 0
-	}
-	return n, err
-}
-
-// fixLongPath returns the extended-length (\\?\-prefixed) form of
-// path when needed, in order to avoid the default 260 character file
-// path limit imposed by Windows. If path is not easily converted to
-// the extended-length form (for example, if path is a relative path
-// or contains .. elements), or is short enough, fixLongPath returns
-// path unmodified.
-//
-// See https://msdn.microsoft.com/en-us/library/windows/desktop/aa365247(v=vs.85).aspx#maxpath
-func fixLongPath(path string) string {
-	// Do nothing (and don't allocate) if the path is "short".
-	// Empirically (at least on the Windows Server 2013 builder),
-	// the kernel is arbitrarily okay with < 248 bytes. That
-	// matches what the docs above say:
-	// "When using an API to create a directory, the specified
-	// path cannot be so long that you cannot append an 8.3 file
-	// name (that is, the directory name cannot exceed MAX_PATH
-	// minus 12)." Since MAX_PATH is 260, 260 - 12 = 248.
-	//
-	// The MSDN docs appear to say that a normal path that is 248 bytes long
-	// will work; empirically the path must be less then 248 bytes long.
-	if len(path) < 248 {
-		// Don't fix. (This is how Go 1.7 and earlier worked,
-		// not automatically generating the \\?\ form)
-		return path
-	}
-
-	// The extended form begins with \\?\, as in
-	// \\?\c:\windows\foo.txt or \\?\UNC\server\share\foo.txt.
-	// The extended form disables evaluation of . and .. path
-	// elements and disables the interpretation of / as equivalent
-	// to \. The conversion here rewrites / to \ and elides
-	// . elements as well as trailing or duplicate separators. For
-	// simplicity it avoids the conversion entirely for relative
-	// paths or paths containing .. elements. For now,
-	// \\server\share paths are not converted to
-	// \\?\UNC\server\share paths because the rules for doing so
-	// are less well-specified.
-	if len(path) >= 2 && path[:2] == `\\` {
-		// Don't canonicalize UNC paths.
-		return path
-	}
-	if !filepath.IsAbs(path) {
-		// Relative path
-		return path
-	}
-
-	const prefix = `\\?`
-
-	pathbuf := make([]byte, len(prefix)+len(path)+len(`\`))
-	copy(pathbuf, prefix)
-	n := len(path)
-	r, w := 0, len(prefix)
-	for r < n {
-		switch {
-		case os.IsPathSeparator(path[r]):
-			// empty block
-			r++
-		case path[r] == '.' && (r+1 == n || os.IsPathSeparator(path[r+1])):
-			// /./
-			r++
-		case r+1 < n && path[r] == '.' && path[r+1] == '.' && (r+2 == n || os.IsPathSeparator(path[r+2])):
-			// /../ is currently unhandled
-			return path
-		default:
-			pathbuf[w] = '\\'
-			w++
-			for ; r < n && !os.IsPathSeparator(path[r]); r++ {
-				pathbuf[w] = path[r]
-				w++
-			}
-		}
-	}
-	// A drive's root directory needs a trailing \
-	if w == len(`\\?\c:`) {
-		pathbuf[w] = '\\'
-		w++
-	}
-	return string(pathbuf[:w])
-}
diff -pruN 0.0~git20200107.26c1120-1fakesync1/sysx/xattr.go 0.0~git20201119.04c754f-2/sysx/xattr.go
--- 0.0~git20200107.26c1120-1fakesync1/sysx/xattr.go	2020-01-07 19:41:36.000000000 +0000
+++ 0.0~git20201119.04c754f-2/sysx/xattr.go	2020-11-19 17:31:50.000000000 +0000
@@ -20,7 +20,6 @@ package sysx
 
 import (
 	"bytes"
-	"syscall"
 
 	"golang.org/x/sys/unix"
 )
@@ -66,60 +65,53 @@ func LGetxattr(path, attr string) ([]byt
 	return getxattrAll(path, attr, unix.Lgetxattr)
 }
 
-const defaultXattrBufferSize = 5
+const defaultXattrBufferSize = 128
 
 type listxattrFunc func(path string, dest []byte) (int, error)
 
 func listxattrAll(path string, listFunc listxattrFunc) ([]string, error) {
-	var p []byte // nil on first execution
-
-	for {
-		n, err := listFunc(path, p) // first call gets buffer size.
+	buf := make([]byte, defaultXattrBufferSize)
+	n, err := listFunc(path, buf)
+	for err == unix.ERANGE {
+		// Buffer too small, use zero-sized buffer to get the actual size
+		n, err = listFunc(path, []byte{})
 		if err != nil {
 			return nil, err
 		}
+		buf = make([]byte, n)
+		n, err = listFunc(path, buf)
+	}
+	if err != nil {
+		return nil, err
+	}
 
-		if n > len(p) {
-			p = make([]byte, n)
-			continue
-		}
-
-		p = p[:n]
-
-		ps := bytes.Split(bytes.TrimSuffix(p, []byte{0}), []byte{0})
-		var entries []string
-		for _, p := range ps {
-			s := string(p)
-			if s != "" {
-				entries = append(entries, s)
-			}
+	ps := bytes.Split(bytes.TrimSuffix(buf[:n], []byte{0}), []byte{0})
+	var entries []string
+	for _, p := range ps {
+		if len(p) > 0 {
+			entries = append(entries, string(p))
 		}
-
-		return entries, nil
 	}
+
+	return entries, nil
 }
 
 type getxattrFunc func(string, string, []byte) (int, error)
 
 func getxattrAll(path, attr string, getFunc getxattrFunc) ([]byte, error) {
-	p := make([]byte, defaultXattrBufferSize)
-	for {
-		n, err := getFunc(path, attr, p)
+	buf := make([]byte, defaultXattrBufferSize)
+	n, err := getFunc(path, attr, buf)
+	for err == unix.ERANGE {
+		// Buffer too small, use zero-sized buffer to get the actual size
+		n, err = getFunc(path, attr, []byte{})
 		if err != nil {
-			if errno, ok := err.(syscall.Errno); ok && errno == syscall.ERANGE {
-				p = make([]byte, len(p)*2) // this can't be ideal.
-				continue                   // try again!
-			}
-
 			return nil, err
 		}
-
-		// realloc to correct size and repeat
-		if n > len(p) {
-			p = make([]byte, n)
-			continue
-		}
-
-		return p[:n], nil
+		buf = make([]byte, n)
+		n, err = getFunc(path, attr, buf)
+	}
+	if err != nil {
+		return nil, err
 	}
+	return buf[:n], nil
 }
diff -pruN 0.0~git20200107.26c1120-1fakesync1/sysx/xattr_unsupported.go 0.0~git20201119.04c754f-2/sysx/xattr_unsupported.go
--- 0.0~git20200107.26c1120-1fakesync1/sysx/xattr_unsupported.go	2020-01-07 19:41:36.000000000 +0000
+++ 0.0~git20201119.04c754f-2/sysx/xattr_unsupported.go	2020-11-19 17:31:50.000000000 +0000
@@ -23,7 +23,7 @@ import (
 	"runtime"
 )
 
-var unsupported = errors.New("extended attributes unsupported on " + runtime.GOOS)
+var errUnsupported = errors.New("extended attributes unsupported on " + runtime.GOOS)
 
 // Listxattr calls syscall listxattr and reads all content
 // and returns a string array
@@ -33,17 +33,17 @@ func Listxattr(path string) ([]string, e
 
 // Removexattr calls syscall removexattr
 func Removexattr(path string, attr string) (err error) {
-	return unsupported
+	return errUnsupported
 }
 
 // Setxattr calls syscall setxattr
 func Setxattr(path string, attr string, data []byte, flags int) (err error) {
-	return unsupported
+	return errUnsupported
 }
 
 // Getxattr calls syscall getxattr
 func Getxattr(path, attr string) ([]byte, error) {
-	return []byte{}, unsupported
+	return []byte{}, errUnsupported
 }
 
 // LListxattr lists xattrs, not following symlinks
@@ -53,12 +53,12 @@ func LListxattr(path string) ([]string,
 
 // LRemovexattr removes an xattr, not following symlinks
 func LRemovexattr(path string, attr string) (err error) {
-	return unsupported
+	return errUnsupported
 }
 
 // LSetxattr sets an xattr, not following symlinks
 func LSetxattr(path string, attr string, data []byte, flags int) (err error) {
-	return unsupported
+	return errUnsupported
 }
 
 // LGetxattr gets an xattr, not following symlinks
diff -pruN 0.0~git20200107.26c1120-1fakesync1/testutil/loopback/loopback_linux.go 0.0~git20201119.04c754f-2/testutil/loopback/loopback_linux.go
--- 0.0~git20200107.26c1120-1fakesync1/testutil/loopback/loopback_linux.go	2020-01-07 19:41:36.000000000 +0000
+++ 0.0~git20201119.04c754f-2/testutil/loopback/loopback_linux.go	2020-11-19 17:31:50.000000000 +0000
@@ -22,8 +22,8 @@ import (
 	"io/ioutil"
 	"os"
 	"os/exec"
-	"syscall"
 	"strings"
+	"syscall"
 
 	"github.com/pkg/errors"
 	"github.com/sirupsen/logrus"
@@ -70,9 +70,9 @@ func New(size int64) (*Loopback, error)
 	}
 
 	l := Loopback{
-		File: file.Name(),
+		File:   file.Name(),
 		Device: deviceName,
-		close: cleanup,
+		close:  cleanup,
 	}
 	return &l, nil
 }
@@ -83,7 +83,7 @@ type Loopback struct {
 	File string
 	// Device is /dev/loopX
 	Device string
-	close func() error
+	close  func() error
 }
 
 // SoftSize returns st_size
diff -pruN 0.0~git20200107.26c1120-1fakesync1/testutil_test.go 0.0~git20201119.04c754f-2/testutil_test.go
--- 0.0~git20200107.26c1120-1fakesync1/testutil_test.go	2020-01-07 19:41:36.000000000 +0000
+++ 0.0~git20201119.04c754f-2/testutil_test.go	2020-11-19 17:31:50.000000000 +0000
@@ -14,6 +14,7 @@
    limitations under the License.
 */
 
+//nolint:unused,deadcode
 package continuity
 
 import (
diff -pruN 0.0~git20200107.26c1120-1fakesync1/.travis.yml 0.0~git20201119.04c754f-2/.travis.yml
--- 0.0~git20200107.26c1120-1fakesync1/.travis.yml	2020-01-07 19:41:36.000000000 +0000
+++ 0.0~git20201119.04c754f-2/.travis.yml	1970-01-01 00:00:00.000000000 +0000
@@ -1,45 +0,0 @@
-language: go
-sudo: required
-
-go:
-  - 1.11.x
-  - 1.12.x
-  - 1.13.x
-  - tip
-
-go_import_path: github.com/containerd/continuity
-
-env:
-  global:
-    - GO111MODULE=on
-  jobs:
-# NOTE: we cannot set GOOS directly (because gimme overrides the value)
-  - TRAVIS_GOOS=windows
-  - TRAVIS_GOOS=linux
-  - TRAVIS_GOOS=darwin
-
-install:
-  - pushd /
-  - GO111MODULE=off go get -u github.com/vbatts/git-validation
-  - GO111MODULE=off go get -u github.com/kunalkushwaha/ltag
-  - popd
-
-before_script:
-  - pushd ..; git clone https://github.com/containerd/project; popd
-
-script:
-  - export GOOS=${TRAVIS_GOOS}
-  - make build binaries
-  - if [ "$GOOS" = "linux" ]; then make vet test; fi
-  - if [ "$GOOS" = "linux" ]; then sudo PATH=$PATH GOPATH=$GOPATH make root-test; fi
-  - if [ "$GOOS" != "linux" ]; then make test-compile; fi
-
-jobs:
-  include:
-    - stage: validate
-      script:
-        - DCO_VERBOSITY=-q ../project/script/validate/dco
-        - ../project/script/validate/fileheader ../project/
-        - ../project/script/validate/vendor
-      go: 1.13.x
-      env: TRAVIS_GOOS=linux
